package kr.co.mkblog.mkblogopenglesexample;

import android.content.Context;
import android.opengl.GLES30;
import android.opengl.Matrix;
import android.util.Log;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import java.nio.IntBuffer;

/**
 * Created by mkblog on 2018-10-30
 */
public class mkGLExample {
    //MK: Triangle Vertex
    float mkCubeVertices[] = {
            -0.5f, -0.5f, -0.5f,  0.0f, 0.0f,
            0.5f, -0.5f, -0.5f,  1.0f, 0.0f,
            0.5f,  0.5f, -0.5f,  1.0f, 1.0f,
            0.5f,  0.5f, -0.5f,  1.0f, 1.0f,
            -0.5f,  0.5f, -0.5f,  0.0f, 1.0f,
            -0.5f, -0.5f, -0.5f,  0.0f, 0.0f,

            -0.5f, -0.5f,  0.5f,  0.0f, 0.0f,
            0.5f, -0.5f,  0.5f,  1.0f, 0.0f,
            0.5f,  0.5f,  0.5f,  1.0f, 1.0f,
            0.5f,  0.5f,  0.5f,  1.0f, 1.0f,
            -0.5f,  0.5f,  0.5f,  0.0f, 1.0f,
            -0.5f, -0.5f,  0.5f,  0.0f, 0.0f,

            -0.5f,  0.5f,  0.5f,  1.0f, 0.0f,
            -0.5f,  0.5f, -0.5f,  1.0f, 1.0f,
            -0.5f, -0.5f, -0.5f,  0.0f, 1.0f,
            -0.5f, -0.5f, -0.5f,  0.0f, 1.0f,
            -0.5f, -0.5f,  0.5f,  0.0f, 0.0f,
            -0.5f,  0.5f,  0.5f,  1.0f, 0.0f,

            0.5f,  0.5f,  0.5f,  1.0f, 0.0f,
            0.5f,  0.5f, -0.5f,  1.0f, 1.0f,
            0.5f, -0.5f, -0.5f,  0.0f, 1.0f,
            0.5f, -0.5f, -0.5f,  0.0f, 1.0f,
            0.5f, -0.5f,  0.5f,  0.0f, 0.0f,
            0.5f,  0.5f,  0.5f,  1.0f, 0.0f,

            -0.5f, -0.5f, -0.5f,  0.0f, 1.0f,
            0.5f, -0.5f, -0.5f,  1.0f, 1.0f,
            0.5f, -0.5f,  0.5f,  1.0f, 0.0f,
            0.5f, -0.5f,  0.5f,  1.0f, 0.0f,
            -0.5f, -0.5f,  0.5f,  0.0f, 0.0f,
            -0.5f, -0.5f, -0.5f,  0.0f, 1.0f,

            -0.5f,  0.5f, -0.5f,  0.0f, 1.0f,
            0.5f,  0.5f, -0.5f,  1.0f, 1.0f,
            0.5f,  0.5f,  0.5f,  1.0f, 0.0f,
            0.5f,  0.5f,  0.5f,  1.0f, 0.0f,
            -0.5f,  0.5f,  0.5f,  0.0f, 0.0f,
            -0.5f,  0.5f, -0.5f,  0.0f, 1.0f
    };

    private float mkPosition[][] = {
            { 0.0f,  0.0f,  0.0f},
            { 2.0f,  5.0f, -15.0f},
            {-1.5f, -2.2f, -2.5f},
            {-3.8f, -2.0f, -12.3f},
            { 2.4f, -0.4f, -3.5f},
            {-1.7f,  3.0f, -7.5f},
            { 1.3f, -2.0f, -2.5f},
            { 1.5f,  2.0f, -2.5f},
            { 1.5f,  0.2f, -1.5f},
            {-1.3f,  1.0f, -1.5f}
    };

    private int[] mkVAO;
    private int[] mkVBO;
    private int[] mkEBO;

    private mkShader mkTriShader;
    private mkTextureLoader brickTexture;
    private mkTextureLoader wallTexture;
    private mkTextureLoader smileTexture;

    private float textureMix;

    public mkGLExample(Context inputContext){


        mkTriShader = new mkShader(inputContext, "mkVertexCode", "mkFragmentCode");

        //MK: Make VAO, VBO
        mkVAO = new int[1];
        GLES30.glGenVertexArrays(1, mkVAO, 0);

        mkVBO = new int[1];
        GLES30.glGenBuffers(1, mkVBO, 0);

        //MK: Make Element Buffer Object (EBO)
        mkEBO = new int[1];
        GLES30.glGenBuffers(1, mkEBO, 0);

        //MK: VAO Bind 이후에 Bind되는 VBO, EBO는 VAO에 저장되는 것으로 판단됨
        GLES30.glBindVertexArray(mkVAO[0]);

        //MK: VBO Bind
        GLES30.glBindBuffer(GLES30.GL_ARRAY_BUFFER, mkVBO[0]);

        //MK: Vertex 좌표를 mkVBO로 복사하는 과정
        ByteBuffer mkByteBuffer = ByteBuffer.allocateDirect(mkCubeVertices.length * 4);
        mkByteBuffer.order(ByteOrder.nativeOrder());
        FloatBuffer mkVertexBuffer = mkByteBuffer.asFloatBuffer();
        mkVertexBuffer.put(mkCubeVertices);
        mkVertexBuffer.position(0);

        GLES30.glBufferData(GLES30.GL_ARRAY_BUFFER, mkCubeVertices.length*4, mkVertexBuffer, GLES30.GL_STATIC_DRAW );

        //MK: mkVBO의 Offset, Vec사이즈 등을 설정하는 부분
        GLES30.glVertexAttribPointer(0, 3, GLES30.GL_FLOAT, false, 5 * 4, 0);
        //MK: mkVBO가 한개 Bind되어서 0으로 설정한듯 함 (계속 공부를 하면서 알아볼 필요가 있음)
        GLES30.glEnableVertexAttribArray(0);

        //MK: mkVBO의 Offset, Vec사이즈 등을 설정하는 부분
        //GLES30.glVertexAttribPointer(1, 3, GLES30.GL_FLOAT, false, 8 * 4, 3 * 4);
        //MK: mkVBO가 한개 Bind되어서 0으로 설정한듯 함 (계속 공부를 하면서 알아볼 필요가 있음)
        //GLES30.glEnableVertexAttribArray(1);

        //MK: Texture Coordinate 좌표를 받기 위해서 설정
        GLES30.glVertexAttribPointer(2, 2, GLES30.GL_FLOAT, false, 5 * 4, 3 * 4);
        GLES30.glEnableVertexAttribArray(2);

        //MK: EBO Bind
        GLES30.glBindBuffer(GLES30.GL_ELEMENT_ARRAY_BUFFER, mkEBO[0]);

        //MK: Indice 값을 mkEBO로 복사하는 과정
        /*
        IntBuffer mkIndexBuffer = mkByteBuffer.asIntBuffer();
        mkIndexBuffer.put(mkIndices);
        mkIndexBuffer.position(0);

        GLES30.glBufferData(GLES30.GL_ELEMENT_ARRAY_BUFFER, mkIndices.length*4, mkIndexBuffer, GLES30.GL_STATIC_DRAW);*/

        brickTexture = new mkTextureLoader(inputContext, "container", GLES30.GL_CLAMP_TO_EDGE, GLES30.GL_CLAMP_TO_EDGE);
        wallTexture = new mkTextureLoader(inputContext, "wall", GLES30.GL_CLAMP_TO_EDGE, GLES30.GL_CLAMP_TO_EDGE);
        smileTexture = new mkTextureLoader(inputContext, "awesomeface", GLES30.GL_REPEAT, GLES30.GL_REPEAT);

        mkTriShader.use(); //MK: Texture가 1개일 때는 정상적으로 동작하는 것 같음. 하지만 2개가 되는 순간부터 마지막만 로딩되는 현상이 있음.
        mkTriShader.setUniformInt("inputTexture", 0);
        mkTriShader.setUniformInt("inputTexture2", 1);
        mkTriShader.setUniformInt("inputTexture3", 2);

        textureMix = 0.0f;
    }

    private float[] mkViewMatrix;
    private float[] mkProjectionMatrix;
    private float[] mkModelMatrix;

    public void calculateViewAndProjectionMatrix(float width, float height){

        //MK: Object가 보이는 방향을 결정하는 부분?
        mkViewMatrix = new float[16];
        Matrix.setIdentityM(mkViewMatrix, 0);
        Matrix.translateM(mkViewMatrix, 0, 0.0f, 0.0f, -3.0f);

        //MK: ProjectionMatrix로 Depth에 따른 물체가 보이는 형태를 결정하는 부분
        mkProjectionMatrix = new float[16];
        Matrix.perspectiveM(mkProjectionMatrix, 0, 45.0f, width / height, 0.1f, 100.0f);

        //MK: 보통 Matrix는 반대로 읽어야 한다고 함.
        //MK: modelMatrix * vertex Vector ==> World Space 로 변경
        //MK: viewMatrix * modelMatrix * vertex Vector ==> View Space로 변경 //정확하진 않는데 아마도 1.0, -1.0등의 좌표가 아니라 사용자가 정의한 값에서 보이는 방향등을 결정하는 단계
        //MK: projectionMatrix * viewMatrix * modelMatrix * vertex Vector ==> clip Space로 변경 //W 값을 나누는 작업과, 1.0 ~ -1.0 사이 값으로 변경하는 Normalizing 작업을 수행
        //MK: Clip Space에서 Screen Space로 변경하는 과정은 ViewPort라는 Hardware Logic이 자동적으로 수행하는 것으로 판단됨.
    }

    public void calculateModelMatrix(float[] translateM, float rotateAngle){
        //MK: Model의 위치나, Rotate 방향등을 결정하는 부분
        mkModelMatrix = new float[16];
        //long milliSecond = System.currentTimeMillis()/50;
        //float rotateAngle = milliSecond % 720;
        //rotateAngle -= 360;
        //rotateAngle %= 360;
        float[] mkTmp = new float[16];
        Matrix.setIdentityM(mkTmp, 0);
        Matrix.translateM(mkTmp, 0, translateM[0], translateM[1], translateM[2]);
        Matrix.setRotateM(mkModelMatrix, 0, rotateAngle, 1.0f, 0.3f, 0.5f);
        Matrix.multiplyMM(mkModelMatrix, 0, mkTmp, 0, mkModelMatrix, 0);
    }

    public void draw(float width, float height, float x, float y){
        //MK: 바로 위에 코드에 setUniformInt에서 설정한 뒤의 숫자에 따라 GL_TEXTURE0, 1등을 설정하는 것으로 판단됨
        GLES30.glActiveTexture(GLES30.GL_TEXTURE1);
        GLES30.glBindTexture(GLES30.GL_TEXTURE_2D, brickTexture.textureID[0]);
        GLES30.glActiveTexture(GLES30.GL_TEXTURE0);
        GLES30.glBindTexture(GLES30.GL_TEXTURE_2D, wallTexture.textureID[0]);
        GLES30.glActiveTexture(GLES30.GL_TEXTURE2);
        GLES30.glBindTexture(GLES30.GL_TEXTURE_2D, smileTexture.textureID[0]);

        //MK: Draw Triangles
        mkTriShader.use();
        GLES30.glBindVertexArray(mkVAO[0]);
        textureMix += (y/1000);
        if(textureMix < 0.0f){
            textureMix = 0.0f;
        }
        else if(textureMix >= 1.0f){
            textureMix = 1.0f;
        }

        calculateViewAndProjectionMatrix(width, height);
        mkTriShader.setUniformMatrix4("mkView", mkViewMatrix);
        mkTriShader.setUniformMatrix4("mkProjection", mkProjectionMatrix);
        mkTriShader.setUniformFloat("inputMix", textureMix);

        for(int i = 0; i < 10; i ++) {
            float angle = 20.0f * i;
            calculateModelMatrix(mkPosition[i], angle);
            mkTriShader.setUniformMatrix4("mkModel", mkModelMatrix);
            GLES30.glDrawArrays(GLES30.GL_TRIANGLES, 0, 36);
        }
    }
}

